/*
    This is part of brecord.
    B-record generation routines.
    Copyright (C) 2006  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __BREC__
#define __BREC__	1

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int DataBrecord(unsigned long int Addr,unsigned char *Data,char *Str);
  /* Dato l'indirizzo corrente e un puntatore al data stream crea un
     B-record contenente i dati specificati. La stringa viene creata
     all'interno del buffer Str e viene terminata, in uscita viene
     restituito il numero di bytes prelevati da Data. */

void EntryBrecord(unsigned long int Addr,char *Str);
  /* Crea un B-record contenente il punto di avvio del programma.
     La stringa viene creata nel buffer Str e viene terminata. */
     
int WriteBrecord(unsigned long int Addr,unsigned long int Value,char *Str);
  /* Crea all'interno di Str un Brecord per la scrittura del valore a 32bit
     Value all'indirizzo Addr. In uscita restituisce la lunghezza del
     brecord. */

int ReadBrecord(unsigned long int Addr,char *Str);
  /* Crea all'interno di Str un Brecord per la lettura del valore a 32bit
     che si trova all'indirizzo Addr. In uscita restituisce la lunghezza del
     brecord. */

/***************************************************************************/
#endif

/* $Source$ */

