/*
    Register names definition.
    Copyright (C) 2007  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __MC9328MX1__
#define __MC9328MX1__	1


/* general GPIO */
#define GPIO_A		0x0021c000UL
#define GPIO_B		0x0021c100UL
#define GPIO_C		0x0021c200UL
#define GPIO_D		0x0021c300UL

/* general register offset */
#define DDIR_OFF	0x000
#define OCR1_OFF	0x004
#define OCR2_OFF	0x008
#define ICONFA1_OFF	0x00c
#define ICONFA2_OFF	0x010
#define ICONFB1_OFF	0x004
#define ICONFB2_OFF	0x018
#define DR_OFF		0x01c
#define GIUS_OFF	0x020
#define SSR_OFF		0x024
#define ICR1_OFF	0x028
#define ICR2_OFF	0x02c
#define IMR_OFF		0x030
#define ISR_OFF		0x034
#define GPR_OFF		0x038
#define SWR_OFF		0x03c
#define PUEN_OFF	0x040

/* GPIO port A */
#define DDIR_A		GPIO_A+0x000
#define OCR1_A		GPIO_A+0x004
#define OCR2_A		GPIO_A+0x008
#define ICONFA1_A	GPIO_A+0x00c
#define ICONFA2_A	GPIO_A+0x010
#define ICONFB1_A	GPIO_A+0x004
#define ICONFB2_A	GPIO_A+0x018
#define DR_A		GPIO_A+0x01c
#define GIUS_A		GPIO_A+0x020
#define SSR_A		GPIO_A+0x024
#define ICR1_A		GPIO_A+0x028
#define ICR2_A		GPIO_A+0x02c
#define IMR_A		GPIO_A+0x030
#define ISR_A		GPIO_A+0x034
#define GPR_A		GPIO_A+0x038
#define SWR_A		GPIO_A+0x03c
#define PUEN_A		GPIO_A+0x040

/* GPIO port B */
#define DDIR_B		GPIO_B+0x000
#define OCR1_B		GPIO_B+0x004
#define OCR2_B		GPIO_B+0x008
#define ICONFA1_B	GPIO_B+0x00c
#define ICONFA2_B	GPIO_B+0x010
#define ICONFB1_B	GPIO_B+0x004
#define ICONFB2_B	GPIO_B+0x018
#define DR_B		GPIO_B+0x01c
#define GIUS_B		GPIO_B+0x020
#define SSR_B		GPIO_B+0x024
#define ICR1_B		GPIO_B+0x028
#define ICR2_B		GPIO_B+0x02c
#define IMR_B		GPIO_B+0x030
#define ISR_B		GPIO_B+0x034
#define GPR_B		GPIO_B+0x038
#define SWR_B		GPIO_B+0x03c
#define PUEN_B		GPIO_B+0x040

/* GPIO port C */
#define DDIR_C		GPIO_C+0x000
#define OCR1_C		GPIO_C+0x004
#define OCR2_C		GPIO_C+0x008
#define ICONFA1_C	GPIO_C+0x00c
#define ICONFA2_C	GPIO_C+0x010
#define ICONFB1_C	GPIO_C+0x004
#define ICONFB2_C	GPIO_C+0x018
#define DR_C		GPIO_C+0x01c
#define GIUS_C		GPIO_C+0x020
#define SSR_C		GPIO_C+0x024
#define ICR1_C		GPIO_C+0x028
#define ICR2_C		GPIO_C+0x02c
#define IMR_C		GPIO_C+0x030
#define ISR_C		GPIO_C+0x034
#define GPR_C		GPIO_C+0x038
#define SWR_C		GPIO_C+0x03c
#define PUEN_C		GPIO_C+0x040

/* GPIO port D */
#define DDIR_D		GPIO_D+0x000
#define OCR1_D		GPIO_D+0x004
#define OCR2_D		GPIO_D+0x008
#define ICONFA1_D	GPIO_D+0x00c
#define ICONFA2_D	GPIO_D+0x010
#define ICONFB1_D	GPIO_D+0x004
#define ICONFB2_D	GPIO_D+0x018
#define DR_D		GPIO_D+0x01c
#define GIUS_D		GPIO_D+0x020
#define SSR_D		GPIO_D+0x024
#define ICR1_D		GPIO_D+0x028
#define ICR2_D		GPIO_D+0x02c
#define IMR_D		GPIO_D+0x030
#define ISR_D		GPIO_D+0x034
#define GPR_D		GPIO_D+0x038
#define SWR_D		GPIO_D+0x03c
#define PUEN_D		GPIO_D+0x040


/* I2C pin definidion */
#define I2C_SDA		15
#define I2C_SCL		16


/* SPI1 pin definition */
#define SPI1_SPI_RDY	13
#define SPI1_SCLK	14
#define SPI1_SS		15
#define SPI1_MISO	16
#define SPI1_MOSI	17


/* SPI2 pin definition */
#define SPI2_SCLK	7
#define SPI2_SS		8
#define SPI2_RXD	9
#define SPI2_TXD	10


/* UART1 pin definition */
#define UART1_RXD	12
#define UART1_TXD	11
#define UART1_RTS	10
#define UART1_CTS	9


/* UART2 pin definition */
#define UART2_RXD	31
#define UART2_TXD	30
#define UART2_RTS	29
#define UART2_CTS	28
#define UART2_DSR	10
#define UART2_RI	9
#define UART2_DCD	8
#define UART2_DTR	7


/* CMOS pin definition */
#define CSI_MCLK	3
#define CSI_D0		4
#define CSI_D1		5
#define CSI_D2		6
#define CSI_D3		7
#define CSI_D4		8
#define CSI_D5		9
#define CSI_D6		10
#define CSI_D7		11
#define CSI_VSYNC	12
#define CSI_HSYNC	13
#define CSI_PIXCLK	14


/* MMCSD pin definition */
#define SD_DAT_0	8
#define SD_DAT_1	9
#define SD_DAT_2	10
#define SD_DAT_3	11
#define SD_CLK		12
#define SD_CMD		13


#endif

/* $Source$ */

