/*
    This is part of mx1rever.
    uP register accessing functions.
    Copyright (C) 2007  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

static const char rcsid[]="$Id$";


/***************************************************************************/
/* include vari */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "serial.h"
#include "brec.h"

/***************************************************************************/
/* define interni alla libreria */

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* variabili interne alla libreria */

static int	SendLen;		// lunghezza stringa inviata
static int	RecvLen;		// lunghezza stringa ricevuta
static char	Send[32];		// buffer invio
static char	Recv[32];		// buffer ricezione

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

void WriteRegister(int SerialPort,unsigned int RegAddr,unsigned int Value);
  /* Scrive il valore passato nel registro specificato. */

unsigned long int ReadRegister(int SerialPort,unsigned int RegAddr);
  /* Legge il valore attuale del registro specificato. */

/***************************************************************************/
/* funzioni */

void WriteRegister(int SerialPort,unsigned int RegAddr,unsigned int Value)
{
  /* Scrive il valore passato nel registro specificato. */



  SendLen=WriteBrecord(RegAddr,Value,Send);		// crea il record
  write(SerialPort,Send,SendLen);			// invia il record
  //RecvLen=read(SerialPort,Recv,32);			// riceve l'echo
  RecvLen=SerRecv(SerialPort,Recv,32);			// riceve l'echo
  if((RecvLen!=(SendLen+1))||(Recv[RecvLen-1]!='/'))
  {
    Send[SendLen]=0;					// termina la stringa
    Recv[RecvLen]=0;					// termina la stringa
    fprintf(stderr,"%s: reply error, SendLen=%i RecvLen=%i\n",
    		__FUNCTION__,SendLen,RecvLen);
    fprintf(stderr,"%s: Send= %s\n",__FUNCTION__,Send);
    fprintf(stderr,"%s: Recv= %s\n",__FUNCTION__,Recv);
  }
  return;						// termina
}



unsigned long int ReadRegister(int SerialPort,unsigned int RegAddr)
{
  /* Legge il valore attuale del registro specificato. */



  //unsigned long int	Value;				// valore letto
  
  
  
  SendLen=ReadBrecord(RegAddr,Send);			// crea il record
  write(SerialPort,Send,SendLen);			// invia il record
  //RecvLen=read(SerialPort,Recv,32);			// riceve l'echo
  RecvLen=SerRecv(SerialPort,Recv,32);			// riceve l'echo
  if((RecvLen!=(SendLen+1+8))||(Recv[RecvLen-1]!='/'))
  {
    Send[SendLen]=0;					// termina la stringa
    Recv[RecvLen]=0;					// termina la stringa
    fprintf(stderr,"%s: reply error, SendLen=%i RecvLen=%i\n",
    		__FUNCTION__,SendLen,RecvLen);
    fprintf(stderr,"%s: Send= %s\n",__FUNCTION__,Send);
    fprintf(stderr,"%s: Recv= %s\n",__FUNCTION__,Recv);
    return 0;						// termina con errore
  }
  Recv[RecvLen-1]=0;					// termina la stringa
  Recv[RecvLen-11]='0';					// aggiunge 0x
  Recv[RecvLen-10]='x';
  return(strtoul(&Recv[RecvLen-11],NULL,16));
  							// traduce il valore
}

/* $Source$ */

